/*# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
#                        pour la Sant�)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
# Previous Authors : Laurent Guigues, Jean-Pierre Roux
# CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
#
#  This software is governed by the CeCILL-B license under French law and
#  abiding by the rules of distribution of free software. You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL-B
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------ */

#ifndef manualView3VContour_h
#define manualView3VContour_h

#include "manualViewContour.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

class manualView3VContour: public manualViewContour
{
public:
	manualView3VContour(int type);
	virtual ~manualView3VContour();
	virtual manualView3VContour * Clone();
	void CopyAttributesTo( manualView3VContour *cloneObject );

	virtual void	RefreshContour();
	virtual int		GetIdPoint(int x, int y, int z);
	virtual	void	UpdateViewPoint(int id);
	virtual bool	ifTouchContour(int x,int y,int z);
			int		GetType();

protected:
private:
	int		_type;
	void	FilterCordinateXYZ(double &x,double &y,double &z);

// JSTG 25-02-08 -------------------------------------
	//manualContourModel				*_manContModel;
//----------------------------------------------------

};

#endif // manualView3VContour_h
